﻿
function chrome_extension_onMessage_addListener(){}

//обработка сообщений из скрипта внедряемого во вкладку code.js
chrome.extension.onMessage.addListener(function(request, sender, callback){
  if(request.cmd =='exec1')
  {
    callback('backMsg'); //обратное сообщение
    console.log('Tis message in background page printed after'
      +' receive of data1 = ', request.h.data1, '; URL= ',sender.url);
  }
  else if (request.cmd =='log') 
  {
	  callback("logged");
	  log(""+request.txt+ ", log from "+sender.url);
  }
  //получен исходный код страницы открытой во вкладке
  else if (request.cmd =='tab_source_code') 
  {
	  callback("cmd tab_source_code ok"); //сообщаем отправителю что все ок	  
	  log("background.js - tab_source_code from "+sender.tab.id+", "+sender.url+", получено символов "+request.txt.length+ "");
	  do_tab_link(sender, request);
	  //обрабатываем код. если не было - формируем do_subcats для ссылки
	  //если есть другие ссылки без do_subcats то переназначаем табу эту ссылку
  }
   else if (request.cmd =='xhr_result') 
  {
	  callback("cmd xhr_result ok"); //сообщаем отправителю что все ок	  
	  log("background.js - xhr_result from "+sender.tab.id+", "+sender.url+", получено символов "+request.txt.length+ "");
	  do_base_link(sender, request);
	  //обрабатываем код. если не было - формируем do_subcats для ссылки
	  //если есть другие ссылки без do_subcats то переназначаем табу эту ссылку
  }
  else if (request.cmd =='popup_register') 
  {
	callback("cmd popup_register ok"); //сообщаем отправителю что все ок	
	log(sender);	  
	log("background.js - popup_register from "+sender.tab.id+", "+sender.url+", получено символов "+request.txt.length+ "");	  

  }
});




function getCurrentTab() {
  return chrome.tabs.getCurrent();

}

chrome.tabs.getSelected(null, function(tab){
    console.log(tab);
});

function reload_target_tab(targetTab)
{
	log("reload_target_tab");
	gtargetTabStatus=0;
	chrome.tabs.reload(parseInt(targetTab));
}

//получаем xhr запрос через открытую вкладку с нужной доской объявлений
function get_from_content_tab(targetTab, url, method, add_headers, body, link)
{
	log("get_from_content_tab, "+targetTab+ ", "+ url);
	//if (gtargetTabStatus==0) {log("target tab not ready"); return;}
	//var url="https://api.leboncoin.fr/finder/search";
	//var body = '{"filters":{"category":{"id":"43"},"enums":{"ad_type":["offer"],"video_game_type":["console"]},"ranges":{"price":{"max":120}}},"owner_type":"all","limit":35,"limit_alu":3,"sort_by":"relevance","sort_order":"desc","offset":0}';
	//var add_headers="api_key:ba0c2dad52b3ec";
	
	chrome.tabs.sendMessage(targetTab, {cmd: "get", url: url, method: method, body:body, add_headers: add_headers, link:link}, function(response) 
	{
		log(response.farewell);
	});
	
}

function chrome_browserAction_onClicked_addListener(){}

chrome.browserAction.onClicked.addListener(function(tab) 
{	
	ext_start(tab);

});
function ext_start(tab)
{
	gtargetTab=tab.id;
	targetTab=gtargetTab;
	
	if (go==0) 
	{	
		get_data_from_glisa(do_glisa_data);
		try {ads_all=JSON.parse(localStorage["ads_all"]); }	catch {}	
		//log("ads_all");
		//log(ads_all);
		chrome.browserAction.setBadgeText({ text: "ON" });		
		//reload_target_tab(targetTab);
		//запускаем обновление вкладки
		//reloads_holder[targetTab] = setInterval(() => {
		//				reload_target_tab(targetTab);
		//			}, 60000);
		//alert("Расширение запущено");
		go=1; 
		//log("set interval holder="+reloads_holder[targetTab]);
		
		//получаем контент с помощью xhr
		//get_from_content_tab(gtargetTab);
		//reloads_holder[targetTab+100] = setInterval(() => 
		//{						
		//	get_from_content_tab(gtargetTab);						
		//}, 10000);	
		checkurl3_holder=setInterval(checkurl3, 2000);
		cron_holder["minute"]=setInterval(cron_minute, 60000);
		cron_holder["hour"]=setInterval(cron_hour, 3600000);
		
	}
	else 
	{
		chrome.browserAction.setBadgeText({ text: "OFF" });
		//останавливаем обновление вкладки
		 //clearInterval(reloads_holder[gtargetTab]);
		 //log("clear interval holder="+reloads_holder[gtargetTab]);
		 //alert("Расширение остановлено");
		 go=0;
		 //clearInterval(reloads_holder[gtargetTab+100]);
		 clearInterval(checkurl3_holder);
		 clearInterval(cron_holder["minute"]);
		 clearInterval(cron_holder["hour"]);
	} 
}



function chrome_tabs_onRemoved_addListener(){}
chrome.tabs.onRemoved.addListener(
	function(targetTab, changeInfo, tab) 
	{
		if (go==0) {return;}
		if (typeof Object.values(tabs_to_open).find((el, idx)  => el.id === targetTab)!="undefined") 
		{
			log("Please don't remove this tab next time, id="+targetTab);
			alert("Please don't remove this tab next time");
		}
	}
)

function chrome_tabs_onUpdated_addListener(){} 

chrome.tabs.onUpdated.addListener(function(targetTab, changeInfo, tab) 
{

	if (typeof opened_tabs[targetTab]=="undefined") {return;}
		
	//log(user_code);
	//alert("chrome.tabs.onUpdated.addListener, user_code="+user_code+", go="+go);
	//log("glisa_data.id="+glisa_data.id);
	if (go==1)
	{
		//получить из хранилища код клиента и юрл глисы
		//restore_user_code();
		//get_data_from_glisa();
		
		//log("changeInfo.status="+changeInfo.status+", "+tab.url+", tab="+targetTab);
		
		if (changeInfo && changeInfo.status === 'complete') 
		{
			if (go==1)
			{
				//log("code.js");
				log("Вкладка обновилась - changeInfo.status="+changeInfo.status+", "+tab.url+", tab="+targetTab);
				gtargetTabStatus=1;
				chrome.tabs.executeScript(targetTab, { file: "content_js/code.js" });			
				code_complete=1;
			}
		}
	}		
});

//получить куку name для домена domain
function getCookie(domain, name, callback) 
{
    chrome.cookies.get({"url": domain, "name": name}, function(cookie) 
	{		
        if(callback) {
            callback(cookie);
        }
    });
}

//ищем сохраненный ранее user_code
function restore_user_code()
{
	if (localStorage["user_code"] && localStorage["glisa_url"]) 
	{
		user_code=localStorage["user_code"];
		glisa_url=localStorage["glisa_url"];	
		log("Считан из localStorage user_code="+localStorage["user_code"]);
	}
	else 
	{
		log("Не найден в хранилище user_code. Ищем куку");
		find_user_code();
	}
}

//ищем код клиента глисы в куках
function find_user_code()
{
	var stop=0;
	for(key in sites_codes) 
	{	
		(function(key){ //эта лабуда сохраняет переменную в текущем состоянии, иначе когда открывается вкладка key уже измененный на следующий
			getCookie("http://"+sites_codes[key], "user_code", function(cookie) {
				log("find_user_code(), кука для "+sites_codes[key]);
				if (cookie!=null) 
				{					
					user_code=cookie.value;
					glisa_url=sites_codes[key];
					localStorage["user_code"]=user_code;
					localStorage["glisa_url"]=glisa_url;
					log("кука найдена value="+ cookie.value + ", key="+key+", glisa_url="+glisa_url);						
					if (stop==0) {get_data_from_glisa(do_glisa_data);	}
					stop=1;
				}
				else {log("кука не найдена");}
			});		
		}) (key);			
		
	}	
	if (user_code=="0") {user_code="-1";} // не удалось найти
	log("find_user_code() user_code="+user_code);
}
restore_user_code();

function change_user_code(new_user_code)
{
	var ar=new_user_code.split("_");
	if (ar.length==3)
	{
		user_code=new_user_code;
		if (typeof sites_codes[ar[0]]!="undefined") 
		{
			glisa_url=sites_codes[ar[0]];
			localStorage["user_code"]=user_code;
			localStorage["glisa_url"]=glisa_url;
		}
		else {return "error";}
	}
	else {return "error";}
	get_data_from_glisa(do_glisa_data);
	return "ok";
}


function get_data_from_glisa(callback)
{
	if (user_code==-1 || glisa_url=="")
	{
		log("Не получаем данные, т.к. user_code="+user_code+", glisa_url="+glisa_url);
		return;
	}
	glisa_data={};
	var url="http://"+glisa_url+"/action.php?mode=api&type=json&user_idc="+user_code+"&ext_version="+ext_version;
	log("Получаем настройки с сервера "+url);
	get_url(url,"", function(json)
	{
		glisa_update_time=unixTime(new Date());
		log("Получены настройки с сервера: "+json);
		glisa_data=JSON.parse(json);		
		if(callback) {
            callback();
        }
	});
}
get_data_from_glisa(do_glisa_data);

//обрабатывает данные полученные с глиса
function do_glisa_data()
{
	//выбираем ссылки поддерживаемые расширением
	var j=0;
	links=[];
	tabs_to_open={};
	//если в исходных данных с глисы есть поле system_message, тогда выводим его в popup
	if (typeof glisa_data.system_message!="undefined") 
	{
		send_to_popup("system_message", glisa_data.system_message);
	}
	for (var i=0; i<glisa_data.links_count;i++)
	{
		if (websites_strong.indexOf(glisa_data.links[i].domain)>-1 ) //если сайт поддерживается
		{
			links[j]=glisa_data.links[i];
			links[j]["url"]=decodeURIComponent(glisa_data.links[i]["url"]);
			links[j]["url"]=convert_link(links[j]["url"], links[j]["domain"]);
			links[j]["referer"]=decodeURIComponent(glisa_data.links[i]["referer"]);
			links[j]["referer"]=convert_link(links[j]["referer"], links[j]["domain"]);			
			links[j].md5=0;
			links[j].checkadsec=Number(links[j].checkadsec);
			links[j].next_check=100-j;
			links[j].link_num=j;
			
			if (typeof tabs_to_open[links[j].domain]=="undefined") 
			{
				//если нет реферера значит не получены данные для доступа по апи
				tabs_to_open[links[j].domain]={};
				if (links[j].referer=="")
				{		
					tabs_to_open[links[j].domain]["url"]=decodeURIComponent(links[j].url);
				}
				else 
				{
					tabs_to_open[links[j].domain]["url"]=decodeURIComponent(links[j].referer);
				}			
				tabs_to_open[links[j].domain].id=-1;
				tabs_to_open[links[j].domain].link_num=j;			
				tabs_to_open[links[j].domain].time=unixTime();	
				tabs_to_open[links[j].domain].ready=false;			
			}
			j++;
		}	
	}
	
	//сортируем массив по скорости проверки
	//links.sort((prev, next) => prev.checkadsec - next.checkadsec);
	log(links);
	
	//отправляем в попап текст для статуса
	send_to_popup("status", html_glisa_data());
	if (go==1 &&  long_poll.activate() && !long_poll.started) {long_poll.run();}
}

function cron_minute()
{
	
}

function cron_hour()
{
	//сначала закрыть все вкладки и остановить. потом обновлять
	get_data_from_glisa(do_glisa_data);
}


function checkurl3()
{		
	//считываем в массив opened_tabs все открытые в браузере вкладки
	get_opened_tabs();
	log("checkurl3");	
	
		  //обрабатываем код. если не было - формируем do_subcats для ссылки
	  //если есть другие ссылки без do_subcats то переназначаем табу эту ссылку

	//если есть массив вкладок
	if (Object.keys(tabs_to_open).length>0)
	{		
		for (var key in tabs_to_open) 
		{			
			var need_open_tab=false;			
			if (tabs_to_open[key].id==-1) 
			{
				log("Вкладку еще ни разу не открывали - " + key);
				need_open_tab=true;
			} 
			else if (typeof opened_tabs[tabs_to_open[key].id] == "undefined")
			{
				log("Вкладку похоже закрыли. Открываем заново - " + key);
				need_open_tab=true;
			}
						
			//|| !Object.values(opened_tabs).includes(tabs_to_open[key].url))
			if (need_open_tab)
			{				
				log("открыть вкладку "+tabs_to_open[key].url);
				(function(key){ //эта лабуда сохраняет переменную в текущем состоянии, иначе когда открывается вкладка key уже измененный на следующий
					chrome.tabs.create({"url":tabs_to_open[key].url,"selected":false}, function(tab)
					{	
						log("Открыли вкладку id=" + tab.id + ", key="+key);		
						opened_tabs[tab.id]=key;
						tabs_to_open[key].id=tab.id;						
					});				
				}) (key);
			}
			//если подошло время то обновляем вкладку
			else if ((tabs_to_open[key].time+update_tab_timeout)<unixTime()) 
			{
				tabs_to_open[key].ready=false;
				tabs_to_open[key].time=unixTime();				
				chrome.tabs.update(tabs_to_open[key].id,{url: tabs_to_open[key].url});
				log("Обновляем вкладку "+tabs_to_open[key].url);
			}
		}
		send_to_popup("opened_tabs", html_tabs_to_open());
	}
	if (links.length==0) {return;}
	
	var links_tmp = JSON.parse(JSON.stringify(links));
	//links_tmp = Object.assign({}, links);
	links_tmp.sort((prev, next) => prev.next_check - next.next_check);
		
	if (links_tmp[0].next_check <= unixTime() )
	{
		log("Проверяем ссылку id="+links_tmp[0].link_id+", "+links_tmp[0].referer);
		
		var link=links_tmp[0];
		if (tabs_to_open[link.domain].ready)
		{
			if (link.domain=="leboncoin.fr") 
			{
				//if (gtargetTabStatus==0) {log("target tab not ready"); return;}
				//var url="https://api.leboncoin.fr/finder/search";
				//var body = '{"filters":{"category":{"id":"43"},"enums":{"ad_type":["offer"],"video_game_type":["console"]},"ranges":{"price":{"max":120}}},"owner_type":"all","limit":35,"limit_alu":3,"sort_by":"relevance","sort_order":"desc","offset":0}';
				//var add_headers="api_key:ba0c2dad52b3ec";
				if (link.url=="" || link.postdata=="" || link.referer=="") 
				{
					log ("Неполные данные по ссылке "+link.url+", "+link.referer);
				}
				else 
				{
					get_from_content_tab(tabs_to_open[link.domain].id, link.url, "POST", make_add_headers(link.domain), link.postdata, link);
				}
			}	
		}
		else 
		{
			log("Вкладка для домена "+link.domain+" не готова");
		}		
		
		links_tmp[0].next_check = unixTime() + links_tmp[0].checkadsec;  
		var link_num=links_tmp[0].link_num;
		links[link_num].next_check = unixTime() + links[link_num].checkadsec;  
        //links.sort((prev, next) => prev.next_check - next.next_check);
	}	
}

//готовит html код с перечнем всех открытых расширением вкладок для popup
function html_tabs_to_open()
{
	var html="";
	var ar=Object.values(tabs_to_open);
	for (var i=0; i<ar.length;i++) 
	{
		if (ar[i].id!=-1) {html+="<a href='"+ar[i].url+"'>"+ar[i].url.substr(0,50)+"</a><br>";}
	}
	return html;
}
//готовит html код с перечнем всех открытых расширением вкладок для popup
function html_glisa_data()
{
	var html="";
	if (typeof glisa_data.email!="undefined") 
	{
		html+="OK. Data received at "+ unixtime_to_string(glisa_update_time)+ " from "+glisa_url;
		html+="<br>Links total: "+links.length;
	}
	else 
	{
		html+="Source data error " + glisa_url;
	}
	return html;
}

	

function test_access()
{
	alert("test_access");
	log("test_access");
}


//отправляем сообщение в popup.js
function send_to_popup(subject, content)
{
	chrome.runtime.sendMessage(
	{
		msg: "to popup.js", 
		data: 
		{
			subject: subject,
			content: content
		}
	});
}
  
//не доделал отсылку результатов лонгполла. все работает, но не удается отправить обратно.
//хром не дает возможность слать по обычному tcp сокету, а мой сокет сервер не поддерживает websocket
//do_base_link в checkurl_f
	










