﻿//получить данные гет запросом и обработать функцией callback	  
function get_url(url, postdata, callback)
{
	var method="";
	if (postdata=="") {method="GET";} else {method="POST";}
	var xhr = new XMLHttpRequest();
	xhr.open(method, url, true); // тут происходит запрос на указанную страницу	
	xhr.onreadystatechange = function() 
	{
		if (xhr.readyState == XMLHttpRequest.DONE && xhr.status == 200) // если всё прошло хорошо, выполняем, что в скобках
		{
			//log(xhr.responseText);	
			if(callback) {	callback(xhr.responseText);	}			
		}
	}
	xhr.send(postdata);
}

function httpGetAsync(url, method, body, add_headers, link, callback)
{
	
    var xmlHttp = new XMLHttpRequest();
	
    xmlHttp.onreadystatechange = function() 
	{ 	
		if (this.readyState != XMLHttpRequest.DONE) return;		
		if (this.status != 200) { return;}		
        callback(link, xmlHttp.responseText);		
    }
	
	xmlHttp.onerror = function() 
	{
		callback(link, "error");
	}
	

    xmlHttp.open(method, url, true); // true for asynchronous 
	
	//устанавливаем доп заголовки
	var headers={};
	var ar=add_headers.split("|");
	for (var i=0; i<ar.length;i++)
	{
		var ar2=ar[i].split(":");
		if (ar2[0].length>1 && ar2[1].length>1) 
		{
			xmlHttp.setRequestHeader(ar2[0], ar2[1]);
			log("xmlHttp.setRequestHeader="+ar2[0]+"==="+ar2[1]);
		}		
	}		
	xmlHttp.withCredentials=true; //посылать куки и прочее	
	//xmlHttp.timeout="10000";
	
	xmlHttp.ontimeout = function() 
	{
		callback(link, "timeout");
	}
	
    xmlHttp.send(body);
}

//unixTime(new Date()) - текущая метка или просто unixTime() для текущего времени
function unixTime(date)
{
	if (date==null) {date=new Date();}
	return Math.round(date.getTime()/1000);
}

function unixtime_to_string(unixtime)
{
	var u = new Date(unixtime*1000);
	return u.toLocaleDateString()+" "+u.toLocaleTimeString().slice(0,-3);
}

function log(ss)
{
	if (log_level==0) {return;}
	var data = new Date();	
	if (typeof(ss)=="object")
	{
		console.log(ss);
	}
	else 
	{
		console.log(data.getHours()+":"+data.getMinutes()+":"+data.getSeconds()+" "+ss);
	}
}

//возвращает из юрл домен без поддоменов - https://www.avito.ru/ufa/kvartiry/ = avito.ru
function get_domain(url)
{
	var ar;
	var	ar2;
	ar=url.split("/");
	if (ar.length<3) {return "";}
	ar2 = ar[2].split(".");
	if (ar.length<2) {return "";}
	ar2 = ar2.reverse();
	return ar2[1]+"."+ar2[0];
}

//получает все открытые вкладки и сохраняет в массив opened_tabs
function get_opened_tabs()
{
	chrome.tabs.query({}, function(tabs) 
	{		
		opened_tabs={};
		for (var tab of tabs) 
		{			
			opened_tabs[tab.id]=tab.url;
		}
	})	
}

//аналог php функции
function http_build_query(parameters)
{
  var qs = "";
  for(var key in parameters) {
    var value = parameters[key];
    qs += encodeURIComponent(key) + "=" + encodeURIComponent(value) + "&";
  }
  if (qs.length > 0){
    qs = qs.substring(0, qs.length-1); //chop off last "&"    
  }
  return qs;
}

//возвращает в виде текста доп заголовки необходимые для xhr запроса для конкрентного домена
function make_add_headers(domain)
{
	if (domain=="leboncoin.fr") {return "api_key:ba0c2dad52b3ec";}
	return "";
}

function convert_link(url, domain)
{
	if (domain=="avito.ru") 
	{
		url=url.replace("http://","https://");
		return url.replace("m.avito.ru", "www.avito.ru");
	}
	return url;
}




