﻿long_poll=
{
	started:false, 
	ip: "46.17.43.243", port: "3127", 
	errors: {counter:0, timeout: 5000, max:20}
};


long_poll.activate=function()
{
	if (typeof glisa_data.longpoll2_ip!="undefined" && glisa_data.longpoll2_ip!="") 
	{		
		long_poll.ip=glisa_data.longpoll2_ip;		
		long_poll.port=glisa_data.longpoll2_port;
		log("long_poll.activate ip="+long_poll.ip+", port="+long_poll.port );
		return true;		
	}
	log("long_poll.activate пустые исходные данные. не активируем");
	return false;
}

long_poll.run=function ()
{
	long_poll.started=true;

	if (user_code=="") {log("long_poll нет user_code"); return;}	

	var domains=Object.keys(tabs_to_open).join(",");
	log("long_poll started. domains="+domains);
	httpGetAsync("http://"+long_poll.ip+":"+long_poll.port, "GET", "", "email:"+user_code+"|glisa:12345|app_key:"+unixTime()+"|version:ext_1|domains:"+domains+"", "", long_poll.callback);
}


long_poll.callback=function (link, txt) 
{
	long_poll.started=false;
	
	if (txt=="error") 
	{	
		
		if (long_poll.errors.counter<long_poll.errors.max) {long_poll.errors.counter++;}
		log("long_poll.callback: "+txt+", пауза="+long_poll.errors.timeout * long_poll.errors.counter);
		setTimeout(long_poll.run, long_poll.errors.timeout * long_poll.errors.counter);
	}
	else 
	{		
		log("long_poll.callback: "+txt);
		var ar=txt.split("<###>");
		var ar=txt.split("<###>");
		var link={resource_id: ar[1], url: ar[2], referer: ar[4], domain: get_domain(ar[4]), postdata: ar[8]}
		link.url=convert_link(link.url, link.domain);
		//если для данного домена предусмотрена вкладка и вкладка готова
		if (typeof tabs_to_open[link.domain]!="undefined" && tabs_to_open[link.domain].ready)
		{
			var type="GET";
			if (link.postdata!="") {type="POST";}
			var add_headers="";			
			get_from_content_tab(tabs_to_open[link.domain].id, link.url, type, make_add_headers(link.domain), link.postdata, link);
		}
		else 
		{
			log("Вкладка для домена не готова - " + link.domain);
		}
		
		long_poll.run();
	}
}

