﻿function log(ss)
{
	ss="popup.js: "+ss;
	//отправляем сообщение в фоновую страницу
	chrome.extension.sendMessage({cmd:'log', txt:ss, 
		function(backMessage){console.log(backMessage);	}
	});
}
log("popup.js started");


chrome.runtime.onMessage.addListener
(
    function(request, sender, sendResponse) 
	{
        if (request.msg === "to popup.js") 
		{			
            //  To do something
            if (request.data.subject=="opened_tabs")
            {
				document.getElementById('opened_tabs').innerHTML=request.data.content;
			}
			else if (request.data.subject=="status")
            {
				document.getElementById('status').innerHTML=request.data.content;
			}
			else if (request.data.subject=="log")
            {
				document.getElementById('log').innerHTML=request.data.content;
			}
			else if (request.data.subject=="system_message")
            {
				if (typeof request.data.content!="undefined")
				{
					document.getElementById('system_message').innerHTML=request.data.content;
				}
			}
        }
    }
);

var bg = chrome.extension.getBackgroundPage(); //дает доступ ко всем методам в background.js
//var response =  bgjs.test_access(); 



let button_start = document.getElementById('button_start');
button_start.addEventListener("click", ext_start);
function ext_start()
{	
    bg.ext_start(1);
	set_start_label();	
}
//меняем название на кнопке
function set_start_label()
{
	if (bg.go==1) 
	{
		button_start.value="Stop";
		document.getElementById('running_div').style.display="inline";
	} 
	else 
	{
		button_start.value="Start";
		document.getElementById('running_div').style.display="none";
	}
}
set_start_label();

document.getElementById('user_code').addEventListener("click", function()
{	
	document.getElementById('user_code_apply').style.display="inline";
});
document.getElementById('user_code').addEventListener("focus", function()
{	
	document.getElementById('user_code_apply').style.display="inline";
});

//меняем user_code
document.getElementById('user_code_apply').addEventListener("click", function()
{	
	if (bg.go==1) {ext_start();} // если расширение запущено - останавливаем
	if (bg.change_user_code(document.getElementById('user_code').value)=="ok")//если код корректный
	{
		document.getElementById('user_code_apply').style.display="none"; //скрываем кнопку
		ext_start(); //запускаем расширение
		document.getElementById('user_code_error').innerHTML="";
	}
	else 
	{
		document.getElementById('user_code_error').innerHTML="error";
		if (bg.user_code.length>3) {document.getElementById('user_code_error').innerHTML+=". Use old user code: "+bg.user_code;}
	}	
});


let span_user_code = document.getElementById('user_code');
let span_user_code_error = document.getElementById('user_code_error');

if (localStorage["user_code"] && localStorage["glisa_url"]) 
{
	span_user_code.value=localStorage["user_code"];
	span_user_code_error.innerHTML="";	
}
else 
{		
	bg.restore_user_code();
	span_user_code_error.innerHTML="User code not found. Please login to <a href='http://"+bg.glisa_url+"' target=_blank>"+bg.glisa_url_default+"</a>";
}

document.getElementById('opened_tabs').innerHTML=bg.html_tabs_to_open();
document.getElementById('status').innerHTML=bg.html_glisa_data();
if (typeof bg.glisa_data.system_message!="undefined")
{	
	document.getElementById('system_message').innerHTML=bg.glisa_data.system_message;
}