//лог пишется в фоновой странице
function log(ss)
{
	//отправляем сообщение в фоновую страницу
	chrome.extension.sendMessage({cmd:'log', txt:ss, 
		function(backMessage){console.log(backMessage);	}
	});
}
log("code.js started");


//принимаем сообщение из фоновой страницы
chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    console.log(sender.tab ?
                "from a content script:" + sender.tab.url :
                "from the extension");
    if (request.cmd == "get") 
	{
      sendResponse({farewell: "Задание get получено. Запускаем httpGetAsync"});
	  httpGetAsync(request.url, request.method, request.body, request.add_headers, request.link, getCallback);
	}	
  });

//для запроса данных по апи, например https://api.leboncoin.fr/finder/search
//body - данные для post, add_headers - дополнительные заголовки
function httpGetAsync(url, method, body, add_headers, link, callback)
{
    var xmlHttp = new XMLHttpRequest();
	
    xmlHttp.onreadystatechange = function() { 
        if (xmlHttp.readyState == XMLHttpRequest.DONE && xmlHttp.status == 200){
            callback(link, xmlHttp.responseText);
		} else {
			
		}
    }

    xmlHttp.open(method, url, true); // true for asynchronous 
	
	//устанавливаем доп заголовки
	var headers={};
	var ar=add_headers.split("|");
	for (var i=0; i<ar.length;i++)
	{
		var ar2=ar[i].split(":");
		if (ar2[0].length>1 && ar2[1].length>1) 
		{
			xmlHttp.setRequestHeader(ar2[0], ar2[1]);
			log("xmlHttp.setRequestHeader="+ar2[0]+"==="+ar2[1]);
		}		
	}		
	xmlHttp.withCredentials=true; //посылать куки и прочее	
    xmlHttp.send(body);
}


function getCallback(link, html)
{
	ss="result OK. Получено символов "+html.length;
	console.log(ss);
	log(ss);
	chrome.runtime.sendMessage({
    cmd: "xhr_result",
    txt: html,
	link: link
});
}

function DOMtoString(document_root) {
    var html = '',
        node = document_root.firstChild;
    while (node) {
        switch (node.nodeType) {
        case Node.ELEMENT_NODE:
            html += node.outerHTML;
            break;
        case Node.TEXT_NODE:
            html += node.nodeValue;
            break;
        case Node.CDATA_SECTION_NODE:
            html += '<![CDATA[' + node.nodeValue + ']]>';
            break;
        case Node.COMMENT_NODE:
            html += '<!--' + node.nodeValue + '-->';
            break;
        case Node.DOCUMENT_TYPE_NODE:
            // (X)HTML documents are identified by public identifiers
            html += "<!DOCTYPE " + node.name + (node.publicId ? ' PUBLIC "' + node.publicId + '"' : '') + (!node.publicId && node.systemId ? ' SYSTEM' : '') + (node.systemId ? ' "' + node.systemId + '"' : '') + '>\n';
            break;
        }
        node = node.nextSibling;
    }
    return html;
}

chrome.runtime.sendMessage({
    cmd: "tab_source_code",
    txt: DOMtoString(document)
});



